
/*********************************************************************
 *Based of nrf24l01 code from http://www.elecfreaks.com
 *And Se8r01 code supplied by supplier,
 *And the final piece from this post:http://bbs.ai-thinker.com/forum.php?mod=viewthread&tid=407 
 *Cant read the language but if you can say thank you from me!!
 *All the pieces put together by me, Stefan (f2k) 151215                          
*Redesigend by Christof Rieger 2017
*********************************************************************/
#include "se8r01.h"

#define IRQq      3  //A0
// IRQ BIT:  Digital Output    Maskable interrupt pin


#define PLOAD_WIDTH  32  // 32 unsigned chars TX payload

#define My_CONFIG (_BV(Se8Bit_TX_DS_OFF)|_BV(Se8Bit_MAX_RT_OFF)|_BV(Se8Bit_EN_CRC)|_BV(Se8Bit_CRCO)|_BV(Se8Bit_PWR_UP))

byte pload_width_now=0;
byte newdata=0;
char signal_lv=0;
byte pip=0;

uint32_t  MainADR = 0x10101043;
byte ADDRESS0 = 0x34;
byte ADDRESS1 = 0xb0;
byte ADDRESS2 = 0xb1;	
byte ADDRESS3 = 0xb2;	
byte ADDRESS4 = 0x43;		
byte ADDRESS5 = 0x10;	

//***************************************************

unsigned char rx_buf[PLOAD_WIDTH]= {0};
unsigned char tx_buf[PLOAD_WIDTH]= {0};
//***************************************************

struct dataStruct2{
  unsigned long counter;
  byte rt;
}myData_pip1; 

struct dataStruct{
  unsigned long counter;
  byte rt;
}myData_pip5;

struct dataStruct1{
  unsigned long counter;
  byte rt;
}myData_pip4;


void setup() 
{
  Serial.begin(115200);
  SE8R01_BEGIN(9, 53);  // Initialize and leave in Idle for MEGA 2560
  SE8R01_FLUSH_RX(); 
  SE8R01Get_STATUS();
  Serial.print("status = ");    
  Serial.println(SE8R01_Status,HEX);     
  Serial.println("*******************Radio starting*****************");

  SE8R01Init_PA_PWR(Se8_PA_OVR);
  SE8R01Set_EN_AA(0b00111111);
  SE8R01Set_EN_RXADDR(0b00111111);
  SE8R01Set_RF_CH(40);
  
  SE8R01Init_ADDR(ADDRESS0,ADDRESS0,MainADR);

  SE8R01Set_RX_ADDR_P1(ADDRESS1);
  SE8R01Set_RX_ADDR_P2(ADDRESS2);
  SE8R01Set_RX_ADDR_P3(ADDRESS3);
  SE8R01Set_RX_ADDR_P4(ADDRESS4);
  SE8R01Set_RX_ADDR_P5(ADDRESS5);

  SE8R01Set_DYNPD(0b00111111);
  SE8R01Set_FEATURE(_BV(Se8Bit_EN_DPL)|_BV(Se8Bit_EN_ACK_PAY));
  SE8R01Set_CONFIG(My_CONFIG|_BV(Se8Bit_PRIM_RX));

  SE8R01Set_ACTIVESTATE();
}
void loop() 
{
 
  if(digitalRead(IRQq)==LOW)
  {
    delayMicroseconds(240);
    signal_lv=SE8R01Get_RPD();
    SE8R01Get_STATUS();
    
    if(SE8R01_Status&_BV(Se8Bit_RX_DR))                                                 // if receive data ready (TX_DS) interrupt
    {
      pip= (SE8R01_Status&0b00001110)>>1;
      pload_width_now=SE8R01Get_RX_PL_WID();
      SE8R01Get_RX_PLOAD(rx_buf,pload_width_now);             // read playload to rx_buf
      SE8R01_FLUSH_RX(); 
      print_pip();
      newdata=1;
      }
   
    SE8R01Set_STATUS(SE8R01_Status);       // clear RX_DR or TX_DS or MAX_RT interrupt flag
  
  }
   
    
  
  if(newdata==1)
  {
  newdata=0;
  if(pip==0)
  {
     unsigned long T_counter=0;
T_counter = (unsigned long)rx_buf[3] << 24;
T_counter += (unsigned long)rx_buf[2] << 16;
T_counter += (unsigned long)rx_buf[1] << 8;
T_counter += (unsigned long)rx_buf[0];

 Serial.print(" transmission counter: ");
 Serial.print(T_counter);
 
     Serial.print(" rt packets: ");
   Serial.print(rx_buf[4]&B00001111);
  }
  
  
  if(pip==1)
  {
 memcpy(&myData_pip1, rx_buf, sizeof(myData_pip1));
 Serial.print(" transmission counter: ");
 Serial.print(myData_pip1.counter);
 Serial.print(" rt packets: ");
 Serial.print(myData_pip1.rt&B00001111);  
  
  }
  
  
  else if(pip==2)
  {
  
  }
  
  else if(pip==3)
  {
   
  } 
   
   
  
 else if(pip==4)
  {
 memcpy(&myData_pip4, rx_buf, sizeof(myData_pip4));
 Serial.print(" transmission counter: ");
 Serial.print(myData_pip4.counter);
 Serial.print(" rt packets: ");
 Serial.print(myData_pip4.rt&B00001111);

    }
    
  
    else if(pip==5)
  {

 memcpy(&myData_pip5, rx_buf, sizeof(myData_pip5));
 Serial.print(" transmission counter: ");
 Serial.print(myData_pip5.counter);
 Serial.print(" rt packets: ");
 Serial.print(myData_pip5.rt&B00001111);

  }
  
  
  Serial.println("");
  
  }
}


 void print_pip()
 {
  if(pip>5)
   {
   Serial.println("NO Data"); 
   }
   else{
   Serial.print(" SS= ");
   Serial.print(signal_lv,DEC);
   Serial.print("  pip: ");    
   Serial.print(pip);
   Serial.print(" ");
   Serial.print("rx buff with= ");
   Serial.print(pload_width_now);
   Serial.print(" data= ");
      for(byte i=0; i<pload_width_now; i++)
      {
          Serial.print(" ");
          Serial.print(rx_buf[i]);                              // print rx_buf
      }
     Serial.print("  ");
 }}
 
 
