/*********************************************************************
 *Based of nrf24l01 code from http://www.elecfreaks.com
 *And Se8r01 code supplied by supplier,
 *And the final piece from this post:http://bbs.ai-thinker.com/forum.php?mod=viewthread&tid=407 
 *Cant read the language but if you can say thank you from me!!
 *All the pieces put together by me, Stefan (f2k) 151215                          
*Redesigend by Christof Rieger 2017
*********************************************************************/
  
#include "se8r01.h"


//This code uses simple software spi so you can change these
//to whatever suits you best.

#define IRQq      3  //A0
// IRQ BIT:  Digital Output    Maskable interrupt pin


struct dataStruct{
  unsigned long counter;
  byte rt;
}myData;


#define PLOAD_WIDTH  sizeof(myData)  // sizeof(myData) unsigned chars TX payload

#define My_CONFIG (_BV(Se8Bit_TX_DS_OFF)|_BV(Se8Bit_MAX_RT_OFF)|_BV(Se8Bit_EN_CRC)|_BV(Se8Bit_CRCO)|_BV(Se8Bit_PWR_UP))

uint32_t  MainADR = 0x10101043;
byte ADDRESS0 = 0x43;

unsigned char tx_buf[PLOAD_WIDTH] = {0};


void setup() 
{  
  Serial.begin(115200);
  SE8R01_BEGIN(8, 4);   // Initialize and leave in Idle for NANO 328
  SE8R01_FLUSH_TX(); 
  SE8R01Get_STATUS();
  Serial.print("status = ");    
  Serial.println(SE8R01_Status,HEX);     
  Serial.println("*******************Radio starting*****************");

  SE8R01Init_PA_PWR(Se8_PA_OVR);

  SE8R01Set_EN_AA(0b00000001);          //enable auto acc on pip 1
  SE8R01Set_EN_RXADDR(0b00000001);      //enable pip 1
  SE8R01Set_RF_CH(40);
  SE8R01Set_SETUP_RETR(0x11);           //lowest 4 bits 0-15 rt transmisston higest 4 bits 256-4096us Auto Retransmit Delay    
  SE8R01Set_DYNPD(0b00000001);          //pipe0 pipe1 enable dynamic payload length data
  SE8R01Set_FEATURE(_BV(Se8Bit_EN_DPL)|_BV(Se8Bit_EN_ACK_PAY));  // enable dynamic paload lenght; enbale payload with ack 
  SE8R01Set_CONFIG(My_CONFIG);

  SE8R01Init_ADDR(ADDRESS0,ADDRESS0,MainADR);      
   
  SE8R01Set_ACTIVESTATE();
}

void loop() 
{

  memcpy(tx_buf, &myData,sizeof(myData));
  SE8R01Get_STATUS();  
  SE8R01Set_TX_PLOAD(tx_buf,PLOAD_WIDTH);
  SE8R01Set_STATUS(0xff); // clear RX_DR or TX_DS or MAX_RT interrupt flag
  delay(10);              //sending data
       
  myData.rt=SE8R01Get_OBSERVE_TX();        //count resends
  Serial.print("status ");
  Serial.print(SE8R01_Status,HEX);
  Serial.print(" rt packets: ");
  Serial.println(myData.rt&B00001111);
  myData.counter++;


delay(200);   
}

